	.module TWI_Master.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\TWI_Master.c
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\TWI_Master.c
_TWI_state:
	.blkb 1
	.area idata
	.byte 248
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\TWI_Master.c
	.dbsym s TWI_state _TWI_state c
_TWI_LastTransOK::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\TWI_Master.c
	.dbsym e TWI_LastTransOK _TWI_LastTransOK c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\TWI_Master.c
	.dbfunc e TWI_Master_Initialize _TWI_Master_Initialize fV
	.even
_TWI_Master_Initialize::
	.dbline -1
	.dbline 91
; /*
;  *
;  * SOC Robotics, Inc
;  *
;  * File - TWI_Master.c
;  *
;  * Compiler - ICCAVR 7.16a
;  * 
;  *
;  * Descrition:
;  *	This TWI module implements an interupt driven TWI Master.
;  * 
;  * 	This Module is based on Atmel's application note AVR315
;  *
;  * Revision: 1.0 -> Date: October 23rd, 2008
;  *		Original										BR
;  *
;  * History:
;  *
;  * Copyright 2008, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC ROBOTICS, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC ROBOTICS, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-machines.com/
;  */
; 
; #include <iom644v.h>
; #include "TWI_Master.h"
; 
; #if defined (TWI_TIMER)
; #include "Timer.h"
; #endif
; 
; #if defined(DEBUG) 
; #include "Serial.h"
; #include "Utilities.h"
; unsigned char text[20];
; #endif
; 
; //Transceiver buffer
; static unsigned char TWI_Buffer[ TWI_BUFFER_SIZE ];
; 
; // Number of bytes to be transmitted.
; static unsigned char TWI_Message_Size;
; 
; // State byte. Default set to TWI_NO_STATE.
; static unsigned char TWI_state = TWI_NO_STATE;
; 
; //Set to one when the last tansaction was ok
; unsigned char TWI_LastTransOK = 0; 
; 
; /*
;  * Call this function to test if the TWI_ISR is busy transmitting/receiving.
;  * If the TWI Interrupt is enabled then the Transceiver is busy
;  * If the TWSTO flag is set then the Transceiver is busy sending a stop condition
;  */
; #define TWI_Transceiver_Busy() ( TWCR & ( (1<<TWIE) | (1<<TWSTO) ) )
; 
; 
; /*
;  * Call this function to set up the TWI master to its initial standby state.
;  * Remember to enable interrupts from the main application after initializing the TWI.
;  */
; void TWI_Master_Initialize(void)
; {
	.dbline 94
; 
; #if ((MCK/(2*SCL_FREQ))-8 < 255 )
; 	TWBR =	(MCK/(2*SCL_FREQ))-8; // Set bit rate register. This sets the fastest SCL frequency. See header file.
	ldi R24,42
	sts 184,R24
	.dbline 107
; 	//prescaler = 1
; #elif ((MCK/(8*SCL_FREQ))-2 < 255 )
; 	TWBR =	(MCK/(8*SCL_FREQ))-2; // Set bit rate register). This sets the fastest SCL frequency. See header file.
; 	TWSR = (1<<TWPS0);//prescaler = 4
; #elif ((MCK/(32*SCL_FREQ)) < 255 )
;     TWBR =	(MCK/(32*SCL_FREQ)); // Set bit rate register). This sets the fastest SCL frequency. See header file.
; 	TWSR = (1<<TWPS1);//prescaler = 16
; #elif ((MCK/(128*SCL_FREQ)) < 255 ) 
;     TWBR =	(MCK/(128*SCL_FREQ)); // Set bit rate register). This sets the fastest SCL frequency. See header file.
; 	TWSR = (1<<TWPS1) | (1<<TWPS0);//prescaler = 64
; #endif
; 
; 	TWCR =	(1<<TWEN)|                        	// Enable TWI-interface
	ldi R24,20
	sts 188,R24
	.dbline 112
; 			(0<<TWIE)|(0<<TWINT)|              	// Interupt disabled
; 			(0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|	// Reset the TWI module and release the SDA SCL lines.  This is in case we are already in the middle for a transaction
; 			(0<<TWWC);
;   
; 	TWDR = 	0xFF; // Default content = SDA released.
	ldi R24,255
	sts 187,R24
	.dbline 114
;   
; 	TWCR = 	(1<<TWEN)|                        // Enable TWI-interface and release TWI pins.
	ldi R24,4
	sts 188,R24
	.dbline 119
;          	(0<<TWIE)|(0<<TWINT)|             // Disable Interupt.
;          	(0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|  // No Signal requests.
;          	(0<<TWWC);
;             
; 	TWI_LastTransOK = 0;
	clr R2
	sts _TWI_LastTransOK,R2
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Master_Disable _TWI_Master_Disable fV
	.even
_TWI_Master_Disable::
	.dbline -1
	.dbline 126
; }
; 
; /*
;  * Call this function to disable the TWI interface
;  */
; void TWI_Master_Disable(void)
; {
	.dbline 127
; 	TWCR =	(1<<TWEN)|                         	// Enable TWI-interface
	ldi R24,148
	sts 188,R24
	.dbline 131
; 			(0<<TWIE)|(1<<TWINT)|            	// Interupt disabled
; 			(0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|	// Reset the TWI module and release the SDA SCL lines.  This is in case we are already in the middle for a transaction
; 			(0<<TWWC);
; 	TWCR =	(0<<TWEN);//Turn off the TWI Interface
	clr R2
	sts 188,R2
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Get_State_Info _TWI_Get_State_Info fc
	.even
_TWI_Get_State_Info::
	.dbline -1
	.dbline 144
; }
; 
; /*
;  * Call this function to fetch the state information of the previous operation.
;  * The function will hold execution (loop) until the TWI has completed with the
;  * previous transaction or until the timer expires. If there was an error,
;  * then the function will return the TWI State code. 
;  *
;  * Returns:	TWI_state
;  *			TWI_TIMEOUT_ERROR if there was a timeout while waiting to get the state info
;  */
; unsigned char TWI_Get_State_Info( void )
; {
L4:
	.dbline 154
; #if defined(TWI_TIMER)    
;     TWI_ERROR_TIMER = TWI_TIMEOUT;//Load the timer with the max time we wish to wait for
;     
; 	while ( TWI_Transceiver_Busy() && (TWI_ERROR_TIMER != 0)); // Wait until TWI is ready for next transmission.
; 	if (!TWI_ERROR_TIMER)//If we stopped waiting due to the timer counting down, return an error code
;     {
;     	return TWI_TIMEOUT_ERROR;
;     }
; #else
; 	while ( TWI_Transceiver_Busy() ); // Wait until TWI is ready for next transmission.
L5:
	.dbline 154
	lds R24,188
	andi R24,17
	brne L4
X0:
	.dbline 157
; #endif
; 
; 	return ( TWI_state );// Return error state.
	lds R16,_TWI_state
	.dbline -2
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Start_Read _TWI_Start_Read fc
;           temp -> R10
;        msgSize -> R18
;        address -> R16
	.even
_TWI_Start_Read::
	st -y,R10
	.dbline -1
	.dbline 174
; }
; 
; 
; /*
;  * Call this function to read msgSize bytes from the slave with address, address
;  *
;  * Warning the function will hold execution (loop) until the TWI has completed
;  * the previous transaction or the timer has elapsed.  If the timer has elapsed
;  * and error code will be returned.
;  *
;  * Returns: TWI_TIMEOUT 			if there was a timeout while waiting
;  *			TWI_NO_ERROR 			if everything was ok
;  *			TWI_TRANSACTION_ERROR 	if there was a problem i.e. there was no device on the bus with that address
;  *
;  */
; unsigned char  TWI_Start_Read( unsigned char address, unsigned char msgSize )
; {
L8:
	.dbline 187
; 	unsigned char temp;
; #if defined(TWI_TIMER)    
;     TWI_ERROR_TIMER = TWI_TIMEOUT;//Load the timer with the max time we wish to wait for
;     
; 	while ( TWI_Transceiver_Busy() && (TWI_ERROR_TIMER != 0)); // Wait until TWI is ready for next transmission.
; 
;     
;     if (!TWI_ERROR_TIMER)//If we stopped waiting due to the timer counting down, return an error code
;     {
;     	return TWI_TIMEOUT_ERROR;
;     }
; #else
; 	while ( TWI_Transceiver_Busy() ); // Wait until TWI is ready for next transmission.
L9:
	.dbline 187
	lds R24,188
	andi R24,17
	brne L8
X1:
	.dbline 190
; #endif
;   
; 	TWI_Buffer[0]  = (address<<1)|1; // Store the slaves address with Read setting
	mov R24,R16
	lsl R24
	ori R24,1
	sts _TWI_Buffer,R24
	.dbline 191
; 	TWI_Message_Size = msgSize+1; // Number of data bytes to transmit + 1 (address)
	mov R24,R18
	subi R24,255    ; addi 1
	sts _TWI_Message_Size,R24
	.dbline 193
;   
; 	temp = TWI_LastTransOK;
	lds R10,_TWI_LastTransOK
	.dbline 195
;     
; 	TWI_LastTransOK = 0;    
	clr R2
	sts _TWI_LastTransOK,R2
	.dbline 197
;   
; 	TWCR =	(1<<TWEN)|                       	// TWI Interface enabled.
	ldi R24,165
	sts 188,R24
	.dbline 202
;          	(1<<TWIE)|(1<<TWINT)|              	// Enable TWI Interupt and clear the flag.
;          	(0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|	// Initiate a START condition.
;          	(0<<TWWC);
;             
;     if( temp ) //return if the last trans was successful             
	tst R10
	breq L11
X2:
	.dbline 203
; 	{                                             
	.dbline 204
;         return TWI_NO_ERROR;
	clr R16
	xjmp L7
L11:
	.dbline 207
; 	}
;     else
;     {
	.dbline 208
;     	return TWI_TRANSACTION_ERROR;
	ldi R16,2
	.dbline -2
L7:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r temp 10 c
	.dbsym r msgSize 18 c
	.dbsym r address 16 c
	.dbend
	.dbfunc e TWI_Get_Data_From_Transceiver _TWI_Get_Data_From_Transceiver fc
;              i -> R20
;        msgSize -> R18
;            msg -> R16,R17
	.even
_TWI_Get_Data_From_Transceiver::
	st -y,R20
	.dbline -1
	.dbline 231
;     }
; }
; 
; /*
;  * Call this function to read out the requested data from the TWI transceiver buffer. 
;  * i.e. first call TWI_Start_Read to send a request for data to the slave. 
;  * Then call this function to collect the data when it arrives.
;  *
;  * Include a pointer to where to place the data and the number of bytes you wish to read
;  *
;  * Warning the function will hold execution (loop) until the TWI has completed
;  * the previous transaction or the timer has elapsed.  If the timer has elapsed
;  * and error code will be returned. If there was an error in the previous
;  * transmission the function will return an error code.
;  *
;  * Returns: TWI_TIMEOUT 			if there was a timeout while waiting
;  *			TWI_NO_ERROR 			if everything was ok
;  *			TWI_TRANSACTION_ERROR 	if there was a problem i.e. there was not device on the bus with that address
; 
;  *
;  */
; unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
; {
L14:
	.dbline 245
; 	unsigned char i;
; 
; #if defined(TWI_TIMER)    
;     TWI_ERROR_TIMER = TWI_TIMEOUT;//Load the timer
;     
; 	while ( TWI_Transceiver_Busy() && (TWI_ERROR_TIMER != 0)); // Wait until TWI is ready for next transmission.
; 
;     
;     if (!TWI_ERROR_TIMER)
;     {
;     	return TWI_TIMEOUT_ERROR;
;     }
; #else
; 	while ( TWI_Transceiver_Busy() ); // Wait until TWI is ready for next transmission.
L15:
	.dbline 245
	lds R24,188
	andi R24,17
	brne L14
X3:
	.dbline 248
; #endif
; 
; 	if( TWI_LastTransOK ) // Copy data if last transmission competed successfully.              
	lds R2,_TWI_LastTransOK
	tst R2
	breq L17
X4:
	.dbline 249
; 	{                                             
	.dbline 250
; 		for ( i=1; i<=msgSize; i++ ) // Copy data from Transceiver buffer. Ignores the TWI Address
	ldi R20,1
	xjmp L22
L19:
	.dbline 251
;     	{
	.dbline 252
;      		msg[ i-1 ] = TWI_Buffer[ i ];
	ldi R24,<_TWI_Buffer
	ldi R25,>_TWI_Buffer
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	mov R30,R20
	clr R31
	sbiw R30,1
	add R30,R16
	adc R31,R17
	std z+0,R2
	.dbline 253
;     	}
L20:
	.dbline 250
	inc R20
L22:
	.dbline 250
	mov R2,R18
	clr R3
	mov R4,R20
	clr R5
	cp R2,R4
	cpc R3,R5
	brge L19
X5:
	.dbline 254
;         return TWI_NO_ERROR;
	clr R16
	xjmp L13
L17:
	.dbline 257
; 	}
;     else
;     {
	.dbline 258
;     	return TWI_TRANSACTION_ERROR;
	ldi R16,2
	.dbline -2
L13:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbsym r msgSize 18 c
	.dbsym r msg 16 pc
	.dbend
	.dbfunc e TWI_Start_Write _TWI_Start_Write fc
;              i -> R20
;        msgSize -> R22
;            msg -> R18,R19
;        address -> R16
	.even
_TWI_Start_Write::
	xcall push_xgsetF000
	ldd R22,y+4
	.dbline -1
	.dbline 278
;     }                                    
; }
; 
; /*
;  * Call this function to write out data to the TWI slave whos address is address.. 
;  *
;  * Include a pointer to where to get the data and the number of bytes you wish to write
;  *
;  * Warning the function will hold execution (loop) until the TWI has completed
;  * the previous transaction or the timer has elapsed.  If the timer has elapsed
;  * and error code will be returned. Otherwise the TWI will be started.
;  *
;  * Returns: TWI_TIMEOUT 			if there was a timeout while waiting
;  *			TWI_NO_ERROR 			if everything was ok
;  *			TWI_TRANSACTION_ERROR 	if there was a problem i.e. there was not device on the bus with that address
;  *
;  */
; 
; unsigned char TWI_Start_Write( unsigned char address, unsigned char *msg, unsigned char msgSize )
; {
L24:
	.dbline 292
; 	unsigned char i;
; 
; #if defined(TWI_TIMER)    
;     TWI_ERROR_TIMER = TWI_TIMEOUT;//load the timer
;     
; 	while ( TWI_Transceiver_Busy() && (TWI_ERROR_TIMER != 0)); // Wait until TWI is ready for next transmission.
; 
;     
;     if (!TWI_ERROR_TIMER)
;     {
;     	return TWI_TIMEOUT_ERROR;
;     }
; #else
; 	while ( TWI_Transceiver_Busy()); // Wait until TWI is ready for next transmission.
L25:
	.dbline 292
	lds R24,188
	andi R24,17
	brne L24
X6:
	.dbline 295
; #endif
; 
; 	TWI_Message_Size = msgSize + 1; // Number of data bytes to transmit.
	mov R24,R22
	subi R24,255    ; addi 1
	sts _TWI_Message_Size,R24
	.dbline 296
; 	TWI_Buffer[0]  = (address<<1); // Store slave address with W setting.
	mov R2,R16
	lsl R2
	sts _TWI_Buffer,R2
	.dbline 299
;   
; 	//copy the data over to my buffer.
; 	for (i = 1; i <= msgSize; i++ )
	ldi R20,1
	xjmp L30
L27:
	.dbline 300
; 	{
	.dbline 301
; 		TWI_Buffer[ i ] = msg[ i - 1 ];
	mov R30,R20
	clr R31
	sbiw R30,1
	add R30,R18
	adc R31,R19
	ldd R2,z+0
	ldi R24,<_TWI_Buffer
	ldi R25,>_TWI_Buffer
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 302
; 	}
L28:
	.dbline 299
	inc R20
L30:
	.dbline 299
	mov R2,R22
	clr R3
	mov R4,R20
	clr R5
	cp R2,R4
	cpc R3,R5
	brge L27
X7:
	.dbline 304
;     
;   	i = TWI_LastTransOK ? TWI_NO_ERROR : TWI_TRANSACTION_ERROR;
	lds R2,_TWI_LastTransOK
	tst R2
	breq L31
X8:
	clr R22
	clr R23
	xjmp L32
L31:
	ldi R22,2
	ldi R23,0
L32:
	mov R20,R22
	.dbline 306
;         
; 	TWI_LastTransOK = 0;      
	clr R2
	sts _TWI_LastTransOK,R2
	.dbline 307
; 	TWI_state = TWI_NO_STATE ;
	ldi R24,248
	sts _TWI_state,R24
	.dbline 308
; 	TWCR = 	(1<<TWEN)|                        // TWI Interface enabled.
	ldi R24,165
	sts 188,R24
	.dbline 313
;          	(1<<TWIE)|(1<<TWINT)|             // Enable TWI Interupt and clear the flag.
;          	(0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|  // Initiate a START condition.
;          	(0<<TWWC);
;             
;    	return i;
	mov R16,R20
	.dbline -2
L23:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r i 20 c
	.dbsym r msgSize 22 c
	.dbsym r msg 18 pc
	.dbsym r address 16 c
	.dbend
	.dbfunc e TWI_LastTransOk _TWI_LastTransOk fc
	.even
_TWI_LastTransOk::
	.dbline -1
	.dbline 327
; 
; }
; 
; 
; /*
;  *
;  * Call this function to determine if the last transaction on the TWI bus was successfull
;  *
;  * Returns: TWI_TIMEOUT 			if there was a timeout while waiting
;  *			TWI_NO_ERROR 			if everything was ok
;  *			TWI_TRANSACTION_ERROR 	if there was a problem i.e. there was not device on the bus with that address
;  */
; unsigned char TWI_LastTransOk( void )
; {
L34:
	.dbline 339
; #if defined(TWI_TIMER)    
;     TWI_ERROR_TIMER = TWI_TIMEOUT;//load the timer
;     
; 	while ( TWI_Transceiver_Busy() && (TWI_ERROR_TIMER != 0)); // Wait until TWI is ready for next transmission.
; 
;     
;     if (!TWI_ERROR_TIMER)
;     {
;     	return TWI_TIMEOUT_ERROR;
;     }
; #else
; 	while ( TWI_Transceiver_Busy() ); // Wait until TWI is ready for next transmission.
L35:
	.dbline 339
	lds R24,188
	andi R24,17
	brne L34
X9:
	.dbline 342
; #endif
; 
;     return TWI_LastTransOK ? TWI_NO_ERROR : TWI_TRANSACTION_ERROR;
	lds R2,_TWI_LastTransOK
	tst R2
	breq L37
X10:
	clr R16
	clr R17
	xjmp L38
L37:
	ldi R16,2
	ldi R17,0
L38:
	.dbline -2
L33:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 104
	jmp _TWI_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\TWI_Master.c
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\TWI_Master.c
L40:
	.blkb 1
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\TWI_Master.c
	.dbfunc e TWI_Interrupt _TWI_Interrupt fV
	.dbsym s TWI_Buffer_Ptr L40 c
	.even
_TWI_Interrupt::
	st -y,R2
	st -y,R3
	st -y,R16
	st -y,R17
	st -y,R24
	st -y,R25
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 353
; }
; 
; /*								********** Interrupt Handler **********
;  *
;  * This function is the Interrupt Service Routine (ISR), and called when the TWI interrupt is triggered;
;  * that is whenever a TWI event has occurred. This function should not be called directly from the main
;  * application.
;  */
; #pragma interrupt_handler TWI_Interrupt:iv_TWI
; void TWI_Interrupt(void)
; {
	.dbline 356
; 	static unsigned char TWI_Buffer_Ptr;//Points to the next byte in the buffer
; 	
;     TWI_state = TWSR; // Store TWSR.
	lds R2,185
	sts _TWI_state,R2
	.dbline 358
;     
; 	switch (TWSR)
	lds R16,185
	clr R17
	cpi R16,40
	ldi R30,0
	cpc R17,R30
	brne X32
	xjmp L45
X32:
X11:
	ldi R24,40
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L56
X12:
L55:
	cpi R16,16
	ldi R30,0
	cpc R17,R30
	brne X33
	xjmp L44
X33:
X13:
	ldi R24,16
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L58
X14:
L57:
	cpi R16,0
	cpc R16,R17
	brne X34
	xjmp L54
X34:
X15:
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge X35
	xjmp L41
X35:
X16:
L59:
	cpi R16,8
	ldi R30,0
	cpc R17,R30
	brne X36
	xjmp L44
X36:
X17:
	xjmp L41
L58:
	cpi R16,24
	ldi R30,0
	cpc R17,R30
	brne X37
	xjmp L45
X37:
X18:
	cpi R16,24
	ldi R30,0
	cpc R17,R30
	brge X38
	xjmp L41
X38:
X19:
L60:
	cpi R16,32
	ldi R30,0
	cpc R17,R30
	brne X39
	xjmp L54
X39:
X20:
	xjmp L41
L56:
	cpi R16,64
	ldi R30,0
	cpc R17,R30
	brne X40
	xjmp L49
X40:
X21:
	ldi R24,64
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L62
X22:
L61:
	cpi R16,48
	ldi R30,0
	cpc R17,R30
	brne X41
	xjmp L54
X41:
X23:
	cpi R16,48
	ldi R30,0
	cpc R17,R30
	brge X42
	xjmp L41
X42:
X24:
L63:
	cpi R16,56
	ldi R30,0
	cpc R17,R30
	brne X43
	xjmp L53
X43:
X25:
	xjmp L41
L62:
	cpi R16,80
	ldi R30,0
	cpc R17,R30
	brne X44
	xjmp L48
X44:
X26:
	ldi R24,80
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L65
X27:
L64:
	cpi R16,72
	ldi R30,0
	cpc R17,R30
	brne X45
	xjmp L54
X45:
X28:
	xjmp L41
L65:
	cpi R16,88
	ldi R30,0
	cpc R17,R30
	brne X46
	xjmp L52
X46:
X29:
	xjmp L41
L44:
	.dbline 362
; 	{
;     	case TWI_START: 		// START has been transmitted  
;     	case TWI_REP_START: 	// Repeated START has been transmitted
;       		TWI_Buffer_Ptr = 0;	// Set buffer pointer to the TWI Address location
	clr R2
	sts L40,R2
L45:
	.dbline 365
;     	case TWI_MTX_ADR_ACK: 	// SLA+W has been tramsmitted and ACK received
;     	case TWI_MTX_DATA_ACK: 	// Data byte has been tramsmitted and ACK received
; 			if (TWI_Buffer_Ptr < TWI_Message_Size)
	lds R2,_TWI_Message_Size
	lds R3,L40
	cp R3,R2
	brsh L46
X30:
	.dbline 366
; 			{
	.dbline 367
; 				TWDR = TWI_Buffer[TWI_Buffer_Ptr++];	//Select the next byte to be transmitted
	mov R2,R3
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	sts L40,R24
	ldi R24,<_TWI_Buffer
	ldi R25,>_TWI_Buffer
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	sts 187,R2
	.dbline 368
; 				TWCR =	(1<<TWEN)|                      // TWI Interface enabled
	ldi R24,133
	sts 188,R24
	.dbline 372
; 						(1<<TWIE)|(1<<TWINT)|           // Enable TWI Interupt and clear the interupt flag
; 						(0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|
; 						(0<<TWWC);                                  
; 			}
	xjmp L42
L46:
	.dbline 374
; 			else // Send STOP after last byte
; 			{
	.dbline 375
; 				TWI_LastTransOK = 1; // Transaction completed successfully. 
	ldi R24,1
	sts _TWI_LastTransOK,R24
	.dbline 376
;         		TWCR =	(1<<TWEN)|                        // TWI Interface enabled
	ldi R24,148
	sts 188,R24
	.dbline 380
;               		 	(0<<TWIE)|(1<<TWINT)|             // Disable TWI Interrupt and clear the interupt flag
;                			(0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|  // Initiate a STOP condition.
;                			(0<<TWWC);
; 			}
	.dbline 382
; 	  
; 			break;
	xjmp L42
L48:
	.dbline 385
; 	  
; 	case TWI_MRX_DATA_ACK: // Data byte has been received and ACK transmitted
; 		TWI_Buffer[TWI_Buffer_Ptr++] = TWDR; //Read in the data
	lds R2,L40
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	sts L40,R24
	ldi R24,<_TWI_Buffer
	ldi R25,>_TWI_Buffer
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	lds R2,187
	std z+0,R2
L49:
	.dbline 389
;       
;     case TWI_MRX_ADR_ACK: // SLA+R has been tramsmitted and ACK received
; 	
; 		if (TWI_Buffer_Ptr < (TWI_Message_Size-1) ) // Detect the last byte so you can NACK it.
	lds R24,_TWI_Message_Size
	subi R24,1
	lds R2,L40
	cp R2,R24
	brsh L50
X31:
	.dbline 390
;       	{
	.dbline 391
;         	TWCR = 	(1<<TWEN)|                        // TWI Interface enabled
	ldi R24,197
	sts 188,R24
	.dbline 395
;                		(1<<TWIE)|(1<<TWINT)|             // Enable TWI Interupt and clear the interupt flag to read next byte
;                		(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|  // Send ACK after reception
;                		(0<<TWWC); 
;       	}
	xjmp L42
L50:
	.dbline 397
;         else // Send NACK after next reception
;       	{ 
	.dbline 398
;         	TWCR = 	(1<<TWEN)|                        // TWI Interface enabled
	ldi R24,133
	sts 188,R24
	.dbline 402
;                		(1<<TWIE)|(1<<TWINT)|             // Enable TWI Interupt and clear the interupt flag to read next byte
;                		(0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|  // Send NACK after reception
;                		(0<<TWWC);
;       	}
	.dbline 404
; 	     
;       	break;
	xjmp L42
L52:
	.dbline 408
; 	   
;     case TWI_MRX_DATA_NACK:// Data byte has been received and NACK tramsmitted
;       
;       	TWI_Buffer[TWI_Buffer_Ptr] = TWDR;//Read in the data
	ldi R24,<_TWI_Buffer
	ldi R25,>_TWI_Buffer
	lds R30,L40
	clr R31
	add R30,R24
	adc R31,R25
	lds R2,187
	std z+0,R2
	.dbline 409
;       	TWI_LastTransOK = 1;// transaction completed successfully. 
	ldi R24,1
	sts _TWI_LastTransOK,R24
	.dbline 411
; 	  
;       	TWCR = 	(1<<TWEN)|                       // TWI Interface enabled
	ldi R24,148
	sts 188,R24
	.dbline 416
;              	(0<<TWIE)|(1<<TWINT)|            // Disable TWI Interrupt and clear the interupt flag
;              	(0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| // Initiate a STOP condition.
;              	(0<<TWWC);
; 			 
;       	break;
	xjmp L42
L53:
	.dbline 420
; 	        
;     case TWI_ARB_LOST: // Arbitration lost
;       	
;         TWCR = 	(1<<TWEN)|                        // TWI Interface enabled
	ldi R24,165
	sts 188,R24
	.dbline 425
;              	(1<<TWIE)|(1<<TWINT)|             // Enable TWI Interupt and clear the intertupt flag
;              	(0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|  // Initiate a (RE)START condition.
;              	(0<<TWWC);
; 			 
;       	break;
	xjmp L42
L54:
L41:
	.dbline 441
; 	  
;     case TWI_MTX_ADR_NACK: // SLA+W has been tramsmitted and NACK received
;     case TWI_MRX_ADR_NACK: // SLA+R has been tramsmitted and NACK received    
;     case TWI_MTX_DATA_NACK: // Data byte has been tramsmitted and NACK received
; //  case TWI_NO_STATE       // No relevant state information available; TWINT = 0
;     case TWI_BUS_ERROR:         // Bus error due to an illegal START or STOP condition
;     default:
;       
; #if defined(DEBUG) 
; 	  	uart0_puts("\nTWI ERROR - ");
; 	  	uart0_puts(Print_Int(TWI_state,text,HEX));
;         uart0_puts("\n");
; #endif        
;         
; 	    // Reset TWI Interface
;       	TWCR = (1<<TWEN)|                       // Enable TWI-interface and release TWI pins
	ldi R24,148
	sts 188,R24
	.dbline 445
;              	(0<<TWIE)|(1<<TWINT)|            // Disable Interupt and clear the intertupt flag (to release the TWI lines)
;              	(0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| // No Signal requests
;              	(0<<TWWC);
; 	}
L42:
	.dbline -2
L39:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R17,y+
	ld R16,y+
	ld R3,y+
	ld R2,y+
	reti
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\TWI_Master.c
_TWI_Message_Size:
	.blkb 1
	.dbsym s TWI_Message_Size _TWI_Message_Size c
_TWI_Buffer:
	.blkb 21
	.dbsym s TWI_Buffer _TWI_Buffer A[21:21]c
; }
