	.module gstep_TWI_Functions.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\MC433G~1.80\gstep_TWI_Functions.c
	.dbfunc e Init_SmartLCD_TWI _Init_SmartLCD_TWI fV
;     twiaddress -> R10
	.even
_Init_SmartLCD_TWI::
	st -y,R10
	mov R10,R16
	sbiw R28,1
	.dbline -1
	.dbline 40
; /**************************************************************************
;  **************************************************************************
;  
;   Program:  Gstep_TWI_Functions		Date: December 29, 2008
;  
;   Author:  S. Swift		    		Version: 1.77
;   
;   Copyright 2002-2009 SOC Robotics, Inc.
;  
;   TWI Functions for handling peripherals such as Motors, DRO's, joysticks
;   etc.
; 		 
;  ***************************************************************************	 
;  ***************************************************************************/
; #include <iom644v.h>
; #include <macros.h>
; #include <ctype.h>
; #include <string.h>
; #include <math.h>
; #include <stdlib.h>
; #include <eeprom.h>
; #include <stdio.h>
; 
; //#include "uart.h"
; #include "Gstep_Defines.h"
; #include "Gstep_Extern.h" 
; #include "gstep_ExternF.h"
; 
; // ***********************************************************************
; // ***********************************************************************
; //     Start of Code
; // ***********************************************************************
; // ***********************************************************************
; 
; 
; #define	   TWI_MTX_ADR_NACK  0x20
; 
; // Configure SmartLCD display device via TWI to accept float
; void  Init_SmartLCD_TWI(unsigned char twiaddress)
; {
	.dbline 41
; 	 messageBuf[0] = 'm';
	ldi R24,109
	sts _messageBuf,R24
	.dbline 42
; 	 messageBuf[1] = 'd';
	ldi R24,100
	sts _messageBuf+1,R24
	.dbline 43
; 	 TWI_Start_Write(twiaddress,messageBuf,2);
	ldi R24,2
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	mov R16,R10
	xcall _TWI_Start_Write
	.dbline -2
L1:
	.dbline 0 ; func end
	adiw R28,1
	ld R10,y+
	ret
	.dbsym r twiaddress 10 c
	.dbend
	.dbfunc e Write_Float_SmartLCD _Write_Float_SmartLCD fV
;          value -> R20,R21
;         fvalue -> y+7
;         axisid -> R12
;     twiaddress -> R10
	.even
_Write_Float_SmartLCD::
	xcall push_xgset303C
	mov R12,R18
	mov R10,R16
	sbiw R28,1
	.dbline -1
	.dbline 48
; }
; 
; // Write float value to LED8 via TWI
; void Write_Float_SmartLCD(unsigned char twiaddress,unsigned char axisid,float fvalue)
; {
	.dbline 51
;  	 void *value;
; 	 
; 	 messageBuf[0] = 'm';
	ldi R24,109
	sts _messageBuf,R24
	.dbline 52
; 	 messageBuf[1] = axisid;
	sts _messageBuf+1,R12
	.dbline 53
; 	 value = &messageBuf[2];
	ldi R20,<_messageBuf+2
	ldi R21,>_messageBuf+2
	.dbline 54
; 	 *(float *)value = fvalue;
	ldd R2,y+7
	ldd R3,y+8
	ldd R4,y+9
	ldd R5,y+10
	movw R30,R20
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
	.dbline 55
; 	 TWI_Start_Write(twiaddress,messageBuf,6);
	ldi R24,6
	std y+0,R24
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	mov R16,R10
	xcall _TWI_Start_Write
	.dbline -2
L3:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgset303C
	.dbsym r value 20 pV
	.dbsym l fvalue 7 D
	.dbsym r axisid 12 c
	.dbsym r twiaddress 10 c
	.dbend
	.dbfunc e Read_SmartLCD_Switches _Read_SmartLCD_Switches fc
;     twiaddress -> R10
	.even
_Read_SmartLCD_Switches::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 59
; }
; 
; unsigned char Read_SmartLCD_Switches(char twiaddress)
; {
	.dbline 60
; 	TWI_Start_Read(twiaddress,3);
	ldi R18,3
	mov R16,R10
	xcall _TWI_Start_Read
	.dbline 61
;     TWI_Get_Data_From_Transceiver(messageBuf,1);
	ldi R18,1
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 62
;     return messageBuf[0];
	lds R16,_messageBuf
	.dbline -2
L6:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r twiaddress 10 c
	.dbend
	.dbfunc e Display_SmartLCD _Display_SmartLCD fV
;           apos -> y+16
;           zpos -> y+12
;           ypos -> y+8
;           xpos -> y+4
	.even
_Display_SmartLCD::
	st -y,R10
	st -y,R11
	sbiw R28,20
	.dbline -1
	.dbline 66
; }
; 
; void Display_SmartLCD()
; {
	.dbline 71
;     float xpos,ypos,zpos,apos;
; 	
; 	//xpos = ((float)xoldpos)*xresolution;
; 	//if(xdirpolarity==NEGATIVE)  xpos = -xpos;
; 	Write_Float_SmartLCD(SMARTLCDTWIADDRESS,'x',xpos);
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,120
	ldi R16,37
	xcall _Write_Float_SmartLCD
	.dbline 72
; 	Delaymsec(4);
	ldi R16,4
	ldi R17,0
	xcall _Delaymsec
	.dbline 76
; 	
; 	//ypos = ((float)yoldpos)*yresolution;
; 	//if(ydirpolarity==NEGATIVE)  ypos = -ypos;
; 	Write_Float_SmartLCD(SMARTLCDTWIADDRESS,'y',ypos);
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,121
	ldi R16,37
	xcall _Write_Float_SmartLCD
	.dbline 77
; 	Delaymsec(4);
	ldi R16,4
	ldi R17,0
	xcall _Delaymsec
	.dbline 81
; 
; 	//zpos = ((float)zoldpos)*zresolution;
; 	//if(zdirpolarity==NEGATIVE)  zpos = -zpos;
; 	Write_Float_SmartLCD(SMARTLCDTWIADDRESS,'z',zpos);
	ldd R2,y+12
	ldd R3,y+13
	ldd R4,y+14
	ldd R5,y+15
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,122
	ldi R16,37
	xcall _Write_Float_SmartLCD
	.dbline 82
; 	Delaymsec(4);
	ldi R16,4
	ldi R17,0
	xcall _Delaymsec
	.dbline 86
; 					  
; 	//apos = ((float)holdpos)*aresolution;
; 	//if(adirpolarity==NEGATIVE)  apos = -apos;
; 	Write_Float_SmartLCD(SMARTLCDTWIADDRESS,'a',apos);
	ldd R2,y+16
	ldd R3,y+17
	ldd R4,y+18
	ldd R5,y+19
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,97
	ldi R16,37
	xcall _Write_Float_SmartLCD
	.dbline -2
L7:
	.dbline 0 ; func end
	adiw R28,20
	ld R11,y+
	ld R10,y+
	ret
	.dbsym l apos 16 D
	.dbsym l zpos 12 D
	.dbsym l ypos 8 D
	.dbsym l xpos 4 D
	.dbend
	.dbfunc e Enumerate_SmartLCD _Enumerate_SmartLCD fV
	.even
_Enumerate_SmartLCD::
	.dbline -1
	.dbline 91
; 	//delaymsec(5);
; }
; 
; void Enumerate_SmartLCD()
; {
	.dbline 92
;  	 smartlcdstate = 0;
	clr R2
	sts _smartlcdstate,R2
	.dbline 95
; 	 
; 	 // Check for Smart Joystick
; 	 Init_SmartLCD_TWI(SMARTLCDTWIADDRESS);
	ldi R16,37
	xcall _Init_SmartLCD_TWI
	.dbline 96
;      if(TWI_Get_State_Info()!=TWI_MTX_ADR_NACK) {
	xcall _TWI_Get_State_Info
	cpi R16,32
	breq L9
X0:
	.dbline 96
	.dbline 97
; 	 	 smartlcdstate |= 0x01;
	lds R24,_smartlcdstate
	ori R24,1
	sts _smartlcdstate,R24
	.dbline 98
; 	 	 Delaymsec(50);
	ldi R16,50
	ldi R17,0
	xcall _Delaymsec
	.dbline 99
; 	 	 Display_SmartLCD();
	xcall _Display_SmartLCD
	.dbline 100
; 		 }
L9:
	.dbline -2
L8:
	.dbline 0 ; func end
	ret
	.dbend
	.area lit(rom, con, rel)
_enummes1::
	.byte 10,13,'E,'n,'u,'m,'e,'r,'a,'t,'e,32,'T,'W,'I,32
	.byte 'D,'e,'v,'i,'c,'e,'s,10,13,0
	.dbsym e enummes1 _enummes1 A[26:26]kc
_enummes8::
	.byte 32,'N,'o,32,'S,'m,'a,'r,'t,'L,'C,'D,32,'f,'o,'u
	.byte 'n,'d,10,13,0
	.dbsym e enummes8 _enummes8 A[21:21]kc
_enummes9::
	.byte 32,'S,'m,'a,'r,'t,'L,'C,'D,32,'f,'o,'u,'n,'d,32
	.byte 45,32,'e,'n,'a,'b,'l,'e,'d,10,13,0
	.dbsym e enummes9 _enummes9 A[28:28]kc
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\MC433G~1.80\gstep_TWI_Functions.c
	.dbfunc e Enumerate_TWI_Devices _Enumerate_TWI_Devices fV
;              i -> <dead>
;      motormask -> R20
	.even
_Enumerate_TWI_Devices::
	st -y,R20
	.dbline -1
	.dbline 108
; }
; 
; const char enummes1[] = "\n\rEnumerate TWI Devices\n\r";
; const char enummes8[] = " No SmartLCD found\n\r";
; const char enummes9[] = " SmartLCD found - enabled\n\r";
; 
; void Enumerate_TWI_Devices()
; {
	.dbline 109
;  	 unsigned char i,motormask=0x01;
	ldi R20,1
	.dbline 111
; 	
; 	 putfs(enummes1);	
	ldi R16,<_enummes1
	ldi R17,>_enummes1
	xcall _putfs
	.dbline 114
; 	  
; 	 // Enumerate SmartLCD
; 	 Enumerate_SmartLCD();
	xcall _Enumerate_SmartLCD
	.dbline 115
; 	 if(smartlcdstate==0) putfs(enummes8);
	lds R2,_smartlcdstate
	tst R2
	brne L12
X1:
	.dbline 115
	ldi R16,<_enummes8
	ldi R17,>_enummes8
	xcall _putfs
	xjmp L13
L12:
	.dbline 116
; 	 else putfs(enummes9);
	ldi R16,<_enummes9
	ldi R17,>_enummes9
	xcall _putfs
L13:
	.dbline -2
L11:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym l i 1 c
	.dbsym r motormask 20 c
	.dbend
	.area lit(rom, con, rel)
_TWImess1::
	.byte 10,13,'T,'W,'I,32,'I,'n,'t,'e,'r,'a,'c,'t,'i,'v
	.byte 'e,32,'C,'o,'m,'m,'a,'n,'d,32,'M,'o,'d,'e,10,13
	.byte 0
	.dbsym e TWImess1 _TWImess1 A[33:33]kc
_TWImess2::
	.byte 'E,'n,'t,'e,'r,32,'t,'w,'i,32,'a,'d,'d,'r,'e,'s
	.byte 's,32,40,'h,'e,'x,45,'t,'w,'o,32,'c,'h,'a,'r,'s
	.byte 41,32,'f,'o,'l,'l,'o,'w,'e,'d,32,'b,'y,32,'A,'S
	.byte 'C,'I,'I,32,'c,'o,'m,'m,'a,'n,'d,'s,10,13,0
	.dbsym e TWImess2 _TWImess2 A[63:63]kc
_TWImess3::
	.byte 32,32,'E,'x,'a,'m,'p,'l,'e,58,32,32,49,52,'x,'t
	.byte 'x,32,32,32,32,'E,'n,'t,'e,'r,32,39,'e,39,32,'t
	.byte 'o,32,'e,'x,'i,'t,10,13,0
	.dbsym e TWImess3 _TWImess3 A[41:41]kc
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\MC433G~1.80\gstep_TWI_Functions.c
	.dbfunc e Execute_TWI_Command _Execute_TWI_Command fV
;     twiaddress -> y+2
;           iptr -> R20
	.even
_Execute_TWI_Command::
	xcall push_xgsetF00C
	sbiw R28,3
	.dbline -1
	.dbline 126
; }
; 
; const char TWImess1[] = "\n\rTWI Interactive Command Mode\n\r";
; const char TWImess2[] = "Enter twi address (hex-two chars) followed by ASCII commands\n\r";
; const char TWImess3[] = "  Example:  14xtx    Enter 'e' to exit\n\r";
; 
; // Send commands on I2C bus given twi address and an ASCII string
; //  TBD - get data command
; void Execute_TWI_Command()
; { 
	.dbline 129
;      unsigned char twiaddress,iptr;
; 	  
; 	 putfs(TWImess1);
	ldi R16,<_TWImess1
	ldi R17,>_TWImess1
	xcall _putfs
	.dbline 130
; 	 putfs(TWImess2);
	ldi R16,<_TWImess2
	ldi R17,>_TWImess2
	xcall _putfs
	.dbline 131
; 	 putfs(TWImess3);
	ldi R16,<_TWImess3
	ldi R17,>_TWImess3
	xcall _putfs
	.dbline 132
; 	 putchar(':');
	ldi R16,58
	xcall _putchar$device_specific$
	xjmp L16
L15:
	.dbline 133
;  	 while((instrg[0]=tolower(getcharr()))!='e') {
	.dbline 134
; 	     instrg[1] = getcharr();
	xcall _getcharr
	sts _instrg+1,R16
	.dbline 135
; 		 instrg[2] = 0;
	clr R2
	sts _instrg+2,R2
	.dbline 136
; 		 sscanf(instrg,"%x",&twiaddress);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,<L20
	ldi R19,>L20
	ldi R16,<_instrg
	ldi R17,>_instrg
	xcall _sscanf
	.dbline 137
; 		 iptr = 0;
	clr R20
	xjmp L22
L21:
	.dbline 138
; 	     while((messageBuf[iptr++]=getcharr())!=CR) {
	.dbline 139
; 		     if(iptr==20) break;
	cpi R20,20
	brne L24
X2:
	.dbline 139
	xjmp L23
L24:
	.dbline 140
; 			 }
L22:
	.dbline 138
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	push R2
	push R3
	xcall _getcharr
	pop R3
	pop R2
	movw R10,R16
	mov R22,R10
	ldi R24,<_messageBuf
	ldi R25,>_messageBuf
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	cpi R16,13
	brne L21
X3:
L23:
	.dbline 141
; 		 messageBuf[iptr] = 0;
	ldi R24,<_messageBuf
	ldi R25,>_messageBuf
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
	.dbline 145
; 		 
; 		 //printf("\n\rtwi=%x %s",twiaddress,messageBuf);
; 		 
; 		 TWI_Start_Write(twiaddress,messageBuf,iptr);
	std y+0,R20
	ldi R18,<_messageBuf
	ldi R19,>_messageBuf
	ldd R16,y+2
	xcall _TWI_Start_Write
	.dbline 147
; 
; 	     putCRLF(); putchar(':');
	xcall _putCRLF
	.dbline 147
	ldi R16,58
	xcall _putchar$device_specific$
	.dbline 148
; 	     }
L16:
	.dbline 133
	xcall _getcharr
	xcall _tolower
	movw R10,R16
	mov R20,R10
	sts _instrg,R20
	cpi R16,101
	breq X5
	xjmp L15
X5:
X4:
	.dbline 149
; 	 putCRLF();
	xcall _putCRLF
	.dbline -2
L14:
	.dbline 0 ; func end
	adiw R28,3
	xjmp pop_xgsetF00C
	.dbsym l twiaddress 2 c
	.dbsym r iptr 20 c
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\MC433G~1.80\gstep_TWI_Functions.c
L20:
	.blkb 3
	.area idata
	.byte 37,'x,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\MC433G~1.80\gstep_TWI_Functions.c
; }
; 
